"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Dict = void 0;
exports.dict = dict;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _tsFns = require("ts-fns");

var _type = require("./type.js");

var _tyError = require("./ty-error.js");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Dict = /*#__PURE__*/function (_Type) {
  (0, _inherits2.default)(Dict, _Type);

  var _super = _createSuper(Dict);

  function Dict(pattern) {
    var _this;

    (0, _classCallCheck2.default)(this, Dict);

    if (!(0, _tsFns.isObject)(pattern)) {
      throw new Error('[Dict]: pattern should be an object.');
    }

    _this = _super.call(this, pattern);
    _this.name = 'Dict';
    return _this;
  }

  (0, _createClass2.default)(Dict, [{
    key: "_decide",
    value: function _decide(value) {
      var pattern = this.pattern;
      var tyerr = new _tyError.TyError();

      if ((0, _tsFns.isEmpty)(pattern)) {
        return null;
      } else if (!(0, _tsFns.isObject)(value)) {
        tyerr.replace({
          type: 'exception',
          value: value,
          name: this.name,
          pattern: pattern
        });
      } else {
        var error = this.validate(value, pattern);

        if (error) {
          tyerr.replace(error);
        }
      }

      tyerr.commit();
      return tyerr.error();
    }
  }, {
    key: "extend",
    value: function extend() {
      var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var current = this.pattern;

      var next = _objectSpread(_objectSpread({}, current), props);

      var Constructor = (0, _tsFns.getConstructorOf)(this);
      var type = new Constructor(next);
      return type;
    }
  }, {
    key: "extract",
    value: function extract() {
      var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var current = this.pattern;
      var next = {};
      var isArr = (0, _tsFns.isArray)(props);
      (0, _tsFns.each)(props, function (value, key) {
        if (isArr && (0, _tsFns.inObject)(value, current)) {
          next[value] = current[value];
        } else if (value && (0, _tsFns.inObject)(key, current)) {
          next[key] = current[key];
        }
      });
      var Constructor = (0, _tsFns.getConstructorOf)(this);
      var type = new Constructor(next);
      return type;
    }
  }]);
  return Dict;
}(_type.Type);

exports.Dict = Dict;

function dict(pattern) {
  var type = new Dict(pattern);
  return type;
}